import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class AI extends Actor
{
    private GreenfootImage img = new GreenfootImage(1, 1);
    
    public AI() {
        setImage(img);
    }
    
    public void act() {
        NimWorld world = (NimWorld) getWorld();
        if(!(world.turn())) {
            //calculate the nim-sum
            String[] rows = world.getRows();
            int[] nimsum = new int[rows.length];
            String ns = "";
            for(int i=0; i < rows.length; i++) {
                for(int k=0; k < rows.length; k++) {
                    String s = "" + rows[k].charAt(i);
                    nimsum[i] += Integer.parseInt(s);
                }
                if(nimsum[i] % 2 != 0) {
                    nimsum[i] = 1;
                    ns += 1;
                }
                else if(nimsum[i] % 2 == 0) {
                    nimsum[i] = 0;
                    ns += 0;
                }
            }
            //check whether we are in a winning situation
            if(Integer.parseInt(ns, 2) != 0) {
                //yes, we are
                //calculate the binary digital sums of
                //the heap sizes and the nim-sum
                int heap = 0;
                int original = 0;
                int limit = 0;
                boolean found = false;
                for(int i=0; i < rows.length; i++) {
                    int o = Integer.parseInt(rows[i], 2);
                    int[] bds = new int[rows.length];
                    String n = "";
                    for(int k=0; k < nimsum.length; k++) {
                        bds[k] = Integer.parseInt(""+rows[i].charAt(k)) + nimsum[k];
                        if(bds[k] % 2 != 0) {
                            bds[k] = 1;
                            n += 1;
                        }
                        else if(bds[k] % 2 == 0) {
                            bds[k] = 0;
                            n += 0;
                        }
                    }
                    //check which heap you have to delete matches from
                    //(the one whose size decreases)
                    if(o > Integer.parseInt(n, 2) && !found) {
                        heap = i;
                        original = o;
                        limit = Integer.parseInt(n, 2);
                        found = true;
                    } 
                }
                //now remove matches from the heap until the actual size
                //is the one calculated above
                Match[] h = world.getHeap(heap);
                int took = 0;
                for(int i=original; i > limit; i--) {
                    boolean removed = false;
                    for(int k=0; k < h.length; k++) {
                        if(!h[k].isHidden() && !removed && took < 3) {
                            h[k].hide();
                            removed = true;
                            took++;
                        }
                    }
                }
                world.endTurn();
            }
            else {
                //if the opponent does not make a mistake
                //we most probably will lose
                int heap = 0;
                int original = 0;
                int limit = 0;
                boolean found = false;
                int high = 0;
                for(int i=0; i < rows.length; i++) {
                    int o = Integer.parseInt(rows[i], 2);
                    if(o > high) {
                        high = o;
                        heap = i;
                    }
                }
                Match[] h = world.getHeap(heap);
                boolean done = false;
                if(high == 1 && !done) {
                    boolean removed = false;
                    for(int k=0; k < h.length; k++) {
                        if(!h[k].isHidden() && !removed) {
                            h[k].hide();
                            removed = true;
                        }
                    }
                    high--;
                    done = true;
                }
                if(high == 2 && !done) {
                    boolean removed = false;
                    for(int k=0; k < h.length; k++) {
                        if(!h[k].isHidden() && !removed) {
                            h[k].hide();
                            removed = true;
                        }
                    }
                    high--;
                    done = true;
                }
                while(high > 2 && !done) {
                    boolean removed = false;
                    for(int k=0; k < h.length; k++) {
                        if(!h[k].isHidden() && !removed) {
                            h[k].hide();
                            removed = true;
                        }
                    }
                    high--;
                }                    
                world.endTurn();
            }
        }
    }
}
