import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class Button extends Actor
{
    private static final Color transparent = new Color(0,0,0,0);
    private GreenfootImage background;
    private String txt;
    private int act = 0;
    
    public Button(String txt, int act) {
        background = getImage();
        this.txt = txt;
        this.act = act;
        GreenfootImage image = new GreenfootImage(background);
        GreenfootImage text = new GreenfootImage(txt, 22, Color.BLACK, transparent);        
        if (text.getWidth() > image.getWidth() - 20) {
            image.scale(text.getWidth() + 20, image.getHeight());
        }        
        image.drawImage(text, (image.getWidth()-text.getWidth())/2, (image.getHeight()-text.getHeight())/2);
        setImage(image);
    }
    
    public void act() {
        if(Greenfoot.mouseClicked(this)) {
            NimWorld world = (NimWorld) getWorld();
            if(act == 0) {
                world.startGame(true);
            }
            if(act == 1) {
                world.startGame(false);
            }
            if(act == 2 && world.turn()) {
                Player p = (Player) getOneIntersectingObject(Player.class);
                p.reset();
                world.endTurn();
            }
        }
    }
}
